package cn.com.qmth.examcloud.core.basic.api.provider;

import io.swagger.annotations.ApiOperation;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import cn.com.qmth.examcloud.common.support.ControllerSupport;
import cn.com.qmth.examcloud.core.basic.api.OrgCloudService;
import cn.com.qmth.examcloud.core.basic.api.request.OrgReq;
import cn.com.qmth.examcloud.core.basic.api.response.OrgResp;
import cn.com.qmth.examcloud.core.basic.dao.entity.Org;
import cn.com.qmth.examcloud.core.basic.service.impl.OrgService;


@RestController
@RequestMapping("${url.prefix}/org")
public class OrgCloudServiceProvider  extends ControllerSupport implements OrgCloudService{

	@Autowired
	private OrgService orgService;
	
	@ApiOperation(value = "保存机构", notes = "保存机构")
	@PostMapping
	@Override
	public OrgResp saveOrg(OrgReq orgReq) throws Exception {
		OrgResp orgResp = new OrgResp();
		Org org = orgService.findFirstByParentIdAndCode(orgReq.getRootOrgId(),orgReq.getOrgCode());
		if(org == null){
			org = new Org();
			org.setName(orgReq.getOrgName());
            org.setCode(orgReq.getOrgCode());
            org.setParentId(orgReq.getRootOrgId());
            org.setRootId(orgReq.getRootOrgId());
            org.setEnable(true);
            org = orgService.save(org);
		}
		orgResp.setId(org.getId());
		orgResp.setName(org.getName());
		return orgResp;
	}
}
